=== debian/changelog ===
ktap (0.4+git20150927-1) unstable; urgency=low

  * Initial release (Closes: #740061)

 -- Azat Khuzhin <a3at.mail@gmail.com>  Sun, 27 Sep 2015 20:25:48 +0300
