=== debian/control ===
Source: ktap
Section: devel
Priority: optional
Maintainer: Azat Khuzhin <a3at.mail@gmail.com>
Build-Depends: debhelper (>= 9),
               dpkg-dev (>= 1.14.6),
               dkms (>= 2.1.1.1),
               libelf-dev,
               pandoc,
               help2man
Standards-Version: 3.9.6
Homepage: http://www.ktap.org
Vcs-Git: git://anonscm.debian.org/collab-maint/ktap.git
Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/ktap.git

Package: ktap
Architecture: any
Depends: libelf1, dkms (>= 2.1.1.1), ${shlibs:Depends}, ${misc:Depends}
Description: lightweight script-based dynamic tracing tool for Linux
 ktap is a new script-based dynamic tracing tool for Linux, it uses a scripting
 language and lets users trace the Linux kernel dynamically. ktap is designed to
 give operational insights with interoperability that allows users to tune,
 troubleshoot and extend kernel and application. It's similar with Linux
 Systemtap and Solaris Dtrace.
 .
 ktap have different design principles from Linux mainstream dynamic tracing
 language in that it's based on bytecode, so it doesn't depend upon GCC, doesn't
 require compiling kernel module for each script, safe to use in production
 environment, fulfilling the embedded ecosystem's tracing needs.
