=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
VERSION = $(shell dpkg-parsechangelog --show-field Version)
DESCRIPTION = $(shell fgrep Description: debian/control | cut -d' ' -f2-)
include /usr/share/dpkg/default.mk

export DEB_CFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
#export DH_VERBOSE=1

# main packaging script based on dh7 syntax
%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- ktap
override_dh_auto_install:
	dh_install ktap /usr/bin/
	dh_dkms -V $(VERSION)
override_dh_auto_clean:
	dh_clean ktap KTAP-CFLAGS
override_dh_install:
	dh_install --exclude=debian Makefile runtime include usr/src/ktapvm-$(VERSION)/

# TODO(azat):
override_dh_auto_test:
#	make load
#	make test
#	make unload

override_dh_installman:
	help2man --no-info --include debian/ktapvm --no-discard-stderr -h-h --version-string $(VERSION) -n "$(DESCRIPTION)" ./ktap > debian/ktap.1
	dh_installman

override_dh_installdocs:
	mkdir -p debian/doc
	pandoc -o debian/doc/tutorial.html doc/tutorial.md
	dh_installdocs debian/doc/tutorial.html
	dh_installdocs samples

override_dh_installchangelogs:
	dh_installchangelogs RELEASES.txt
