=== debian/changelog ===
ktap (0.4+git20160427-1ubuntu4) bionic; urgency=medium

  * Linux 5.2 and 5.3 compatibility (LP: #1849569)
    - debian/patches/fix-stacktrace-5.2.patch
    - debian/patches/fix-tracing_generic_entry_update-5.3.patch

 -- Marcelo Henrique Cerri <marcelo.cerri@canonical.com>  Fri, 15 Nov 2019 16:30:33 -0300

ktap (0.4+git20160427-1ubuntu3) artful; urgency=medium

  * Linux 4.13 compatibility (LP: #1706427)
    - debian/patches/remove-strlen-user.patch

 -- Seth Forshee <seth.forshee@canonical.com>  Wed, 09 Aug 2017 08:12:13 -0500

ktap (0.4+git20160427-1ubuntu2) zesty; urgency=medium

  * linux v4.10 compatibility
    debian/patches/cycle-t.patch

 -- Tim Gardner <tim.gardner@canonical.com>  Thu, 16 Feb 2017 09:18:34 -0700

ktap (0.4+git20160427-1ubuntu1) zesty; urgency=medium

  * linux v4.9 compatibility
    debian/patches/gfp-nowait.patch
    debian/patches/perf-record-data.patch 

 -- Tim Gardner <tim.gardner@canonical.com>  Thu, 15 Dec 2016 11:07:32 -0700

ktap (0.4+git20160427-1) unstable; urgency=medium

  * Sync with upstream (Closes: #803241)

 -- Azat Khuzhin <a3at.mail@gmail.com>  Wed, 27 Apr 2016 18:49:03 +0300
