=== debian/watch ===
version=3
opts="filenamemangle=s/(?:.*?)?v?(\d[\d.]*)\.tar\.gz/ktap-$1.tar.gz/" \
    https://github.com/ktap/ktap/tags (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
